"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportEvent(ProtocolElement):
    """
    A report event holds all the information about why a given variant is
    relevant to report. The same variant may have several report
    events. For instance, we may have two report events from the
    tiering process when two panels are analysed, a positive report
    from a Genomic Medicine Centre (GMC) will correspond to an
    additional report event.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "genomicEntities",
        "modeOfInheritance",
        "phenotypes",
        "reportEventId",
        "variantConsequences",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "actions": reports_6_4_0.Actions,
            "algorithmBasedVariantClassifications": reports_6_4_0.AlgorithmBasedVariantClassification,
            "evidenceEntry": reports_6_4_0.EvidenceEntry,
            "genePanel": reports_6_4_0.GenePanel,
            "genomicEntities": reports_6_4_0.GenomicEntity,
            "guidelineBasedVariantClassification": reports_6_4_0.GuidelineBasedVariantClassification,
            "phenotypes": reports_6_4_0.Phenotypes,
            "variantClassification": reports_6_4_0.VariantClassification,
            "variantConsequences": reports_6_4_0.VariantConsequence,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import participant as participant_1_4_0
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "domain": reports_6_4_0.Domain,
            "modeOfInheritance": reports_6_4_0.ModeOfInheritance,
            "penetrance": participant_1_4_0.Penetrance,
            "roleInCancer": reports_6_4_0.RoleInCancer,
            "segregationPattern": reports_6_4_0.SegregationPattern,
            "tier": reports_6_4_0.Tier,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import participant as participant_1_4_0
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "org.gel.models.report.avro.Actions": reports_6_4_0.Actions,
            "org.gel.models.report.avro.AlgorithmBasedVariantClassification": reports_6_4_0.AlgorithmBasedVariantClassification,
            "org.gel.models.report.avro.Domain": reports_6_4_0.Domain,
            "org.gel.models.report.avro.EvidenceEntry": reports_6_4_0.EvidenceEntry,
            "org.gel.models.report.avro.GenePanel": reports_6_4_0.GenePanel,
            "org.gel.models.report.avro.GenomicEntity": reports_6_4_0.GenomicEntity,
            "org.gel.models.report.avro.GuidelineBasedVariantClassification": reports_6_4_0.GuidelineBasedVariantClassification,
            "org.gel.models.report.avro.ModeOfInheritance": reports_6_4_0.ModeOfInheritance,
            "org.gel.models.participant.avro.Penetrance": participant_1_4_0.Penetrance,
            "org.gel.models.report.avro.Phenotypes": reports_6_4_0.Phenotypes,
            "org.gel.models.report.avro.RoleInCancer": reports_6_4_0.RoleInCancer,
            "org.gel.models.report.avro.SegregationPattern": reports_6_4_0.SegregationPattern,
            "org.gel.models.report.avro.Tier": reports_6_4_0.Tier,
            "org.gel.models.report.avro.VariantClassification": reports_6_4_0.VariantClassification,
            "org.gel.models.report.avro.VariantConsequence": reports_6_4_0.VariantConsequence,
            "org.gel.models.report.avro.ReportEvent": reports_6_4_0.ReportEvent,
        }

    __slots__ = [
        "genomicEntities",
        "modeOfInheritance",
        "phenotypes",
        "reportEventId",
        "variantConsequences",
        "actions",
        "algorithmBasedVariantClassifications",
        "deNovoQualityScore",
        "domain",
        "eventJustification",
        "evidenceEntry",
        "fullyExplainsPhenotype",
        "genePanel",
        "groupOfVariants",
        "guidelineBasedVariantClassification",
        "penetrance",
        "roleInCancer",
        "score",
        "segregationPattern",
        "tier",
        "variantClassification",
        "vendorSpecificScores",
    ]

    def __init__(
        self,
        genomicEntities,
        modeOfInheritance,
        phenotypes,
        reportEventId,
        variantConsequences,
        actions=None,
        algorithmBasedVariantClassifications=None,
        deNovoQualityScore=None,
        domain=None,
        eventJustification=None,
        evidenceEntry=None,
        fullyExplainsPhenotype=None,
        genePanel=None,
        groupOfVariants=None,
        guidelineBasedVariantClassification=None,
        penetrance=None,
        roleInCancer=None,
        score=None,
        segregationPattern=None,
        tier=None,
        variantClassification=None,
        vendorSpecificScores=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_4_0.ReportEvent model.

        :param genomicEntities:
            The list of genomic features of interest for this report event. Please
            note that one variant can overlap more that one
            gene/transcript. If more than one gene/transcript is
            considered interesting for this particular variant, should
            be reported in two different ReportEvents
        :type genomicEntities: list[GenomicEntity]
        :param modeOfInheritance:
            Mode of inheritance used to analyse the family
        :type modeOfInheritance: ModeOfInheritance
        :param phenotypes:
            The list of phenotypes
        :type phenotypes: Phenotypes
        :param reportEventId:
            Unique identifier for each report event, this is unique across the
            whole report. A report having more than one report event
            with the same identifier is invalid. Repeating report
            event identifiers between different reports is valid. The
            uniqueness of this field will be checked in report
            validation
        :type reportEventId: str
        :param variantConsequences:
            Sequence Ontology terms for relevant consequence types for this report
            event
        :type variantConsequences: list[VariantConsequence]
        :param actions:
            Actions can be taken on the variant if any
        :type actions: None | Actions
        :param algorithmBasedVariantClassifications:
            Algorithm based variant classifications
        :type algorithmBasedVariantClassifications: None | list[AlgorithmBasedVariantClassification]
        :param deNovoQualityScore:
            Likelihood of being a de novo variant
        :type deNovoQualityScore: None | float
        :param domain:
            The Domain where this variant has been classified.
        :type domain: None | Domain
        :param eventJustification:
            This is the description of why this variant would be reported, for
            example that it affects the protein in this way and that
            this gene has been implicated in this disorder in these
            publications. Publications should be provided as PMIDs
            using the format [PMID:8075643]. Other sources can be used
            in the same manner, e.g. [OMIM:163500]. Brackets need to
            be included.
        :type eventJustification: None | str
        :param evidenceEntry:
            An entry for an evidence
        :type evidenceEntry: None | EvidenceEntry
        :param fullyExplainsPhenotype:
            Flag to indicate if this variant using this mode of inheritance can
            fully explain the phenotype
        :type fullyExplainsPhenotype: None | boolean
        :param genePanel:
            The panel of genes to which this report corresponds
        :type genePanel: None | GenePanel
        :param groupOfVariants:
            This value groups variants that together could explain the phenotype
            according to the mode of inheritance used. (e.g.: compound
            heterozygous). All the variants in the same report sharing
            the same value will be considered in the same group (i.e.:
            reported together). This value is an integer unique in the
            whole report. These values are only relevant within the
            same report.
        :type groupOfVariants: None | int
        :param guidelineBasedVariantClassification:
            Guidelines based Variant classification
        :type guidelineBasedVariantClassification: None | GuidelineBasedVariantClassification
        :param penetrance:
            This is the penetrance assumed for scoring or classifying this variant
        :type penetrance: None | Penetrance
        :param roleInCancer:
            The role of this variant in cancer if any
        :type roleInCancer: None | list[RoleInCancer]
        :param score:
            This is the score provided to reflect a variant's likelihood of
            explaining the phenotype using a specific mode of
            Inheritance. This may be the result of different scoring
            systems
        :type score: None | float
        :param segregationPattern:
            Segregation pattern if any calculated using the genotypes information
            of a family
        :type segregationPattern: None | SegregationPattern
        :param tier:
            The tier where this variant has been classified. Tier is a property of
            the model of inheritance and therefore is subject to
            change depending on the inheritance assumptions
        :type tier: None | Tier
        :param variantClassification:
            Variant classification
        :type variantClassification: None | VariantClassification
        :param vendorSpecificScores:
            Other scores that the interpretation provider may add (for example
            phenotypically informed or family informed scores)
        :type vendorSpecificScores: None | dict[str, float]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.4.0"
